org.apache.catalina.valves

## Class AccessLogValve

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.valves.ValveBase
      - - org.apache.catalina.valves.AccessLogValve

All Implemented Interfaces:
  MBeanRegistration, AccessLog, Contained, Lifecycle, Valve

Direct Known Subclasses:
  ExtendedAccessLogValve

    public class AccessLogValve
    extends ValveBase
    implements AccessLog

Implementation of the Valve interface that generates a web server access log with the detailed line contents matching a configurable pattern. The syntax of the available patterns is similar to that supported by the Apache HTTP Server `mod_log_config` module. As an additional feature, automatic rollover of log files when the date changes is also supported.

Patterns for the logged message may include constant text or any of the following replacement strings, for which the corresponding information from the specified Response is substituted:

- %a - Remote IP address
- %A - Local IP address
- %b - Bytes sent, excluding HTTP headers, or '-' if no bytes were sent
- %B - Bytes sent, excluding HTTP headers
- %h - Remote host name (or IP address if `enableLookups` for the connector is false)
- %H - Request protocol
- %l - Remote logical username from identd (always returns '-')
- %m - Request method
- %p - Local port
- %q - Query string (prepended with a '?' if it exists, otherwise an empty string
- %r - First line of the request
- %s - HTTP status code of the response
- %S - User session ID
- %t - Date and time, in Common Log Format format
- %t{format} - Date and time, in any format supported by SimpleDateFormat
- %u - Remote user that was authenticated
- %U - Requested URL path
- %v - Local server name
- %D - Time taken to process the request, in millis
- %T - Time taken to process the request, in seconds
- %I - current Request thread name (can compare later with stacktraces)

In addition, the caller can specify one of the following aliases for commonly utilized patterns:

- common - `%h %l %u %t "%r" %s %b`
- combined - `%h %l %u %t "%r" %s %b "%{Referer}i" "%{User-Agent}i"`

There is also support to write information from the cookie, incoming header, the Session or something else in the ServletRequest.
It is modeled after the Apache HTTP Server log configuration syntax:

- `%{xxx}i` for incoming headers
- `%{xxx}o` for outgoing response headers
- `%{xxx}c` for a specific cookie
- `%{xxx}r` xxx is an attribute in the ServletRequest
- `%{xxx}s` xxx is an attribute in the HttpSession
- `%{xxx}t` xxx is an enhanced SimpleDateFormat pattern (see Configuration Reference document for details on supported time patterns)

Log rotation can be on or off. This is dictated by the `rotatable` property.

For UNIX users, another field called `checkExists` is also available. If set to true, the log file's existence will be checked before each logging. This way an external log rotator can move the file somewhere and Tomcat will start with a new file.

For JMX junkies, a public method called `rotate` has been made available to allow you to tell this instance to move the existing log file to somewhere else and start writing a new log file.

Conditional logging is also supported. This can be done with the `conditionUnless` and `conditionIf` properties. If the value returned from ServletRequest.getAttribute(conditionUnless) yields a non-null value, the logging will be skipped. If the value returned from ServletRequest.getAttribute(conditionIf) yields the null value, the logging will be skipped. The `condition` attribute is synonym for `conditionUnless` and is provided for backwards compatibility.

For extended attributes coming from a getAttribute() call, it is you responsibility to ensure there are no newline or control characters.

Author:
  Craig R. McClanahan, Jason Brittain, Remy Maucherat, Takayuki Kaneko, Peter Rossbach

### Nested Class Summary

Nested Classes
`protected static interface` `AccessLogValve.AccessLogElement` AccessLogElement writes the partial message into the buffer.
`protected static class` `AccessLogValve.ByteSentElement` write bytes sent, excluding HTTP headers - %b, %B
`protected static class` `AccessLogValve.CookieElement` write a specific cookie - %{xxx}c
`protected class` `AccessLogValve.DateAndTimeElement` write date and time, in configurable format (default CLF) - %t or %t{format}
`protected static class` `AccessLogValve.DateFormatCache` Cache structure for formatted timestamps based on seconds.
`protected static class` `AccessLogValve.ElapsedTimeElement` write time taken to process the request - %D, %T
`protected static class` `AccessLogValve.FirstByteTimeElement` write time until first byte is written (commit time) in millis - %F
`protected static class` `AccessLogValve.HeaderElement` write incoming headers - %{xxx}i
`protected class` `AccessLogValve.HostElement` write remote host name - %h
`protected static class` `AccessLogValve.HttpStatusCodeElement` write HTTP status code of the response - %s
`protected static class` `AccessLogValve.LocalAddrElement` write local IP address - %A
`protected class` `AccessLogValve.LocalPortElement` write local port on which this request was received - %p
`protected static class` `AccessLogValve.LocalServerNameElement` write local server name - %v
`protected static class` `AccessLogValve.LogicalUserNameElement` write remote logical username from identd (always returns '-') - %l
`protected static class` `AccessLogValve.MethodElement` write request method (GET, POST, etc.) - %m
`protected class` `AccessLogValve.ProtocolElement` write request protocol - %H
`protected static class` `AccessLogValve.QueryElement` write Query string (prepended with a '?'
`protected class` `AccessLogValve.RemoteAddrElement` write remote IP address - %a
`protected static class` `AccessLogValve.RequestAttributeElement` write an attribute in the ServletRequest - %{xxx}r
`protected static class` `AccessLogValve.RequestElement` write first line of the request (method and request URI) - %r
`protected static class` `AccessLogValve.RequestURIElement` write requested URL path - %U
`protected static class` `AccessLogValve.ResponseHeaderElement` write a specific response header - %{xxx}o
`protected static class` `AccessLogValve.SessionAttributeElement` write an attribute in the HttpSession - %{xxx}s
`protected static class` `AccessLogValve.SessionIdElement` write user session ID - %S
`protected static class` `AccessLogValve.StringElement` write any string
`protected static class` `AccessLogValve.ThreadNameElement` write thread name - %I
`protected static class` `AccessLogValve.UserElement` write remote user that was authenticated (if any), else '-' - %u

### Field Summary

Fields
`protected String` `condition` Are we doing conditional logging. default null.
`protected String` `conditionIf` Are we doing conditional logging. default null.
`protected File` `currentLogFile` The current log file we are writing to.
`protected boolean` `enabled` enabled this component
`protected String` `encoding` Character set used by the log file.
`protected String` `fileDateFormat` Date format to place in log file name.
`protected SimpleDateFormat` `fileDateFormatter` A date formatter to format a Date using the format given by `fileDateFormat`.
`protected static String` `info` The descriptive information about this implementation.
`protected Locale` `locale` Locale used to format timestamps in log entries and in log file name suffix.
`protected String` `localeName` Name of locale used to format timestamps in log entries and in log file name suffix.
`protected AccessLogValve.AccessLogElement[]` `logElements` Array of AccessLogElement, they will be used to make log message.
`protected String` `pattern` The pattern used to format our access log lines.
`protected String` `prefix` The prefix that is added to log file filenames.
`protected boolean` `renameOnRotate` Should we defer inclusion of the date stamp in the file name until rotate time?
`protected boolean` `requestAttributesEnabled`
`protected boolean` `rotatable` Should we rotate our log file?
`protected String` `suffix` The suffix that is added to log file filenames.
`protected PrintWriter` `writer` The PrintWriter to which we are currently logging, if any.

### Fields inherited from class org.apache.catalina.valves.ValveBase

`asyncSupported, container, containerLog, next, sm`

### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

`mserver`

### Fields inherited from interface org.apache.catalina.AccessLog

`PROTOCOL_ATTRIBUTE, REMOTE_ADDR_ATTRIBUTE, REMOTE_HOST_ATTRIBUTE, SERVER_PORT_ATTRIBUTE`

### Fields inherited from interface org.apache.catalina.Lifecycle

`AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

### Constructor Summary

Constructors
Constructor and Description
`AccessLogValve()`

### Method Summary

Methods
`void` `backgroundProcess()` Execute a periodic task, such as reloading, etc.
`protected AccessLogValve.AccessLogElement` `createAccessLogElement(char pattern)` create an AccessLogElement implementation
`protected AccessLogValve.AccessLogElement` `createAccessLogElement(String header, char pattern)` create an AccessLogElement implementation which needs header string
`protected AccessLogValve.AccessLogElement[]` `createLogElements()` parse pattern string and create the array of AccessLogElement
`protected static Locale` `findLocale(String name, Locale fallback)` Find a locale by name
`String` `getCondition()` Return whether the attribute name to look for when performing conditional logging.
`String` `getConditionIf()` Return whether the attribute name to look for when performing conditional logging.
`String` `getConditionUnless()` Return whether the attribute name to look for when performing conditional logging.
`String` `getDirectory()` Return the directory in which we create log files.
`boolean` `getEnabled()`
`String` `getEncoding()` Return the character set name that is used to write the log file.
`String` `getFileDateFormat()` Return the date format date based log rotation.
`String` `getInfo()` Return descriptive information about this implementation.
`String` `getLocale()` Return the locale used to format timestamps in log entries and in log file name suffix.
`String` `getPattern()` Return the format pattern.
`String` `getPrefix()` Return the log file prefix.
`boolean` `getRequestAttributesEnabled()`
`String` `getSuffix()` Return the log file suffix.
`void` `invoke(Request request, Response response)` Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.
`boolean` `isBuffered()` Is the logging buffered
`boolean` `isCheckExists()` Check for file existence before logging.
`boolean` `isRenameOnRotate()` Should we defer inclusion of the date stamp in the file name until rotate time
`boolean` `isResolveHosts()` Deprecated. Unused, removed in Tomcat 8. See org.apache.catalina.connector.Connector.setEnableLookups(boolean).
`boolean` `isRotatable()` Should we rotate the logs
`void` `log(Request request, Response response, long time)` Add the request/response to the access log using the specified processing time.
`void` `log(String message)` Log the specified message to the log file, switching files if the date has changed since the previous log call.
`protected void` `open()` Open the new log file for the date specified by `dateStamp`.
`void` `rotate()` Rotate the log file if necessary.
`boolean` `rotate(String newFileName)` Rename the existing log file to something else.
`void` `setBuffered(boolean buffered)` Set the value if the logging should be buffered
`void` `setCheckExists(boolean checkExists)` Set whether to check for log file existence before logging.
`void` `setCondition(String condition)` Set the ServletRequest.attribute to look for to perform conditional logging.
`void` `setConditionIf(String condition)` Set the ServletRequest.attribute to look for to perform conditional logging.
`void` `setConditionUnless(String condition)` Set the ServletRequest.attribute to look for to perform conditional logging.
`void` `setDirectory(String directory)` Set the directory in which we create log files.
`void` `setEnabled(boolean enabled)`
`void` `setEncoding(String encoding)` Set the character set that is used to write the log file.
`void` `setFileDateFormat(String fileDateFormat)` Set the date format date based log rotation.
`void` `setLocale(String localeName)` Set the locale used to format timestamps in log entries and in log file name suffix.
`void` `setPattern(String pattern)` Set the format pattern, first translating any recognized alias.
`void` `setPrefix(String prefix)` Set the log file prefix.
`void` `setRenameOnRotate(boolean renameOnRotate)` Set the value if we should defer inclusion of the date stamp in the file name until rotate time
`void` `setRequestAttributesEnabled(boolean requestAttributesEnabled)` Should this valve set request attributes for IP address, Hostname, protocol and port used for the request?
`void` `setResolveHosts(boolean resolveHosts)` Deprecated. Unused, removed in Tomcat 8. See org.apache.catalina.connector.Connector.setEnableLookups(boolean).
`void` `setRotatable(boolean rotatable)` Set the value is we should we rotate the logs
`void` `setSuffix(String suffix)` Set the log file suffix.
`protected void` `startInternal()` Start this component and implement the requirements of `LifecycleBase.startInternal()`.
`protected void` `stopInternal()` Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.

### Methods inherited from class org.apache.catalina.valves.ValveBase

`event, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, toString`

### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

`destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister`

### Methods inherited from class org.apache.catalina.util.LifecycleBase

`addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, init, removeLifecycleListener, setState, setState, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### info

    protected static final String info

The descriptive information about this implementation.

See Also:
  Constant Field Values

#### enabled

    protected boolean enabled

enabled this component

#### pattern

    protected String pattern

The pattern used to format our access log lines.

#### prefix

    protected String prefix

The prefix that is added to log file filenames.

#### rotatable

    protected boolean rotatable

Should we rotate our log file? Default is true (like old behavior)

#### renameOnRotate

    protected boolean renameOnRotate

Should we defer inclusion of the date stamp in the file name until rotate time? Default is false.

#### suffix

    protected String suffix

The suffix that is added to log file filenames.

#### writer

    protected PrintWriter writer

The PrintWriter to which we are currently logging, if any.

#### fileDateFormatter

    protected SimpleDateFormat fileDateFormatter

A date formatter to format a Date using the format given by `fileDateFormat`.

#### currentLogFile

    protected File currentLogFile

The current log file we are writing to. Helpful when checkExists is true.

#### condition

    protected String condition

Are we doing conditional logging. default null. It is the value of `conditionUnless` property.

#### conditionIf

    protected String conditionIf

Are we doing conditional logging. default null. It is the value of `conditionIf` property.

#### fileDateFormat

    protected String fileDateFormat

Date format to place in log file name.

#### localeName

    protected String localeName

Name of locale used to format timestamps in log entries and in log file name suffix.

#### locale

    protected Locale locale

Locale used to format timestamps in log entries and in log file name suffix.

#### encoding

    protected String encoding

Character set used by the log file. If it is `null`, the system default character set will be used. An empty string will be treated as `null` when this property is assigned.

#### logElements

    protected AccessLogValve.AccessLogElement[] logElements

Array of AccessLogElement, they will be used to make log message.

#### requestAttributesEnabled

    protected boolean requestAttributesEnabled

See Also:
  `setRequestAttributesEnabled(boolean)`

### Constructor Detail

#### AccessLogValve

    public AccessLogValve()

### Method Detail

#### getEnabled

    public boolean getEnabled()

Returns:
  Returns the enabled.

#### setRequestAttributesEnabled

    public void setRequestAttributesEnabled(boolean requestAttributesEnabled)

Should this valve set request attributes for IP address, Hostname, protocol and port used for the request? This are typically used in conjunction with the `AccessLogValve` which will otherwise log the original values. Default is `true`. The attributes set are:

- org.apache.catalina.RemoteAddr
- org.apache.catalina.RemoteHost
- org.apache.catalina.Protocol
- org.apache.catalina.ServerPost

Specified by:
  `setRequestAttributesEnabled` in interface `AccessLog`
Parameters:
  `requestAttributesEnabled` - `true` causes the attributes to be set, `false` disables the setting of the attributes.

#### getRequestAttributesEnabled

    public boolean getRequestAttributesEnabled()

Specified by:
  `getRequestAttributesEnabled` in interface `AccessLog`
Returns:
  `true` if the attributes will be logged, otherwise `false`
See Also:
  `AccessLog.setRequestAttributesEnabled(boolean)`

#### setEnabled

    public void setEnabled(boolean enabled)

Parameters:
  `enabled` - The enabled to set.

#### getDirectory

    public String getDirectory()

Return the directory in which we create log files.

#### setDirectory

    public void setDirectory(String directory)

Set the directory in which we create log files.

Parameters:
  `directory` - The new log file directory

#### getInfo

    public String getInfo()

Return descriptive information about this implementation.

Specified by:
  `getInfo` in interface `Valve`
Overrides:
  `getInfo` in class `ValveBase`

#### getPattern

    public String getPattern()

Return the format pattern.

#### setPattern

    public void setPattern(String pattern)

Set the format pattern, first translating any recognized alias.

Parameters:
  `pattern` - The new pattern

#### isCheckExists

    public boolean isCheckExists()

Check for file existence before logging.

#### setCheckExists

    public void setCheckExists(boolean checkExists)

Set whether to check for log file existence before logging.

Parameters:
  `checkExists` - true meaning to check for file existence.

#### getPrefix

    public String getPrefix()

Return the log file prefix.

#### setPrefix

    public void setPrefix(String prefix)

Set the log file prefix.

Parameters:
  `prefix` - The new log file prefix

#### isRotatable

    public boolean isRotatable()

Should we rotate the logs

#### setRotatable

    public void setRotatable(boolean rotatable)

Set the value is we should we rotate the logs

Parameters:
  `rotatable` - true is we should rotate.

#### isRenameOnRotate

    public boolean isRenameOnRotate()

Should we defer inclusion of the date stamp in the file name until rotate time

#### setRenameOnRotate

    public void setRenameOnRotate(boolean renameOnRotate)

Set the value if we should defer inclusion of the date stamp in the file name until rotate time

Parameters:
  `renameOnRotate` - true if defer inclusion of date stamp

#### isBuffered

    public boolean isBuffered()

Is the logging buffered

#### setBuffered

    public void setBuffered(boolean buffered)

Set the value if the logging should be buffered

Parameters:
  `buffered` - true if buffered.

#### getSuffix

    public String getSuffix()

Return the log file suffix.

#### setSuffix

    public void setSuffix(String suffix)

Set the log file suffix.

Parameters:
  `suffix` - The new log file suffix

#### setResolveHosts

    @Deprecated
    public void setResolveHosts(boolean resolveHosts)

Deprecated. Unused, removed in Tomcat 8. See org.apache.catalina.connector.Connector.setEnableLookups(boolean).
Set the resolve hosts flag.

Parameters:
  `resolveHosts` - The new resolve hosts value

#### isResolveHosts

    @Deprecated
    public boolean isResolveHosts()

Deprecated. Unused, removed in Tomcat 8. See org.apache.catalina.connector.Connector.setEnableLookups(boolean).
Get the value of the resolve hosts flag.

#### getCondition

    public String getCondition()

Return whether the attribute name to look for when performing conditional logging. If null, every request is logged.

#### setCondition

    public void setCondition(String condition)

Set the ServletRequest.attribute to look for to perform conditional logging. Set to null to log everything.

Parameters:
  `condition` - Set to null to log everything

#### getConditionUnless

    public String getConditionUnless()

Return whether the attribute name to look for when performing conditional logging. If null, every request is logged.

#### setConditionUnless

    public void setConditionUnless(String condition)

Set the ServletRequest.attribute to look for to perform conditional logging. Set to null to log everything.

Parameters:
  `condition` - Set to null to log everything

#### getConditionIf

    public String getConditionIf()

Return whether the attribute name to look for when performing conditional logging. If null, every request is logged.

#### setConditionIf

    public void setConditionIf(String condition)

Set the ServletRequest.attribute to look for to perform conditional logging. Set to null to log everything.

Parameters:
  `condition` - Set to null to log everything

#### getFileDateFormat

    public String getFileDateFormat()

Return the date format date based log rotation.

#### setFileDateFormat

    public void setFileDateFormat(String fileDateFormat)

Set the date format date based log rotation.

#### getLocale

    public String getLocale()

Return the locale used to format timestamps in log entries and in log file name suffix.

#### setLocale

    public void setLocale(String localeName)

Set the locale used to format timestamps in log entries and in log file name suffix. Changing the locale is only supported as long as the AccessLogValve has not logged anything. Changing the locale later can lead to inconsistent formatting.

Parameters:
  `localeName` - The locale to use.

#### getEncoding

    public String getEncoding()

Return the character set name that is used to write the log file.

Returns:
  Character set name, or `null` if the system default character set is used.

#### setEncoding

    public void setEncoding(String encoding)

Set the character set that is used to write the log file.

Parameters:
  `encoding` - The name of the character set.

#### backgroundProcess

    public void backgroundProcess()

Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

Specified by:
  `backgroundProcess` in interface `Valve`
Overrides:
  `backgroundProcess` in class `ValveBase`

#### invoke

    public void invoke(Request request,
              Response response)
                throws IOException,
                       ServletException

Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.

Specified by:
  `invoke` in interface `Valve`
Specified by:
  `invoke` in class `ValveBase`
Parameters:
  `request` - Request being processed
  `response` - Response being processed
Throws:
  `IOException` - if an input/output error has occurred
  `ServletException` - if a servlet error has occurred

#### log

    public void log(Request request,
           Response response,
           long time)

Description copied from interface: `AccessLog`
Add the request/response to the access log using the specified processing time.

Specified by:
  `log` in interface `AccessLog`
Parameters:
  `request` - Request (associated with the response) to log
  `response` - Response (associated with the request) to log
  `time` - Time taken to process the request/response in milliseconds (use 0 if not known)

#### rotate

    public void rotate()

Rotate the log file if necessary.

#### rotate

    public boolean rotate(String newFileName)

Rename the existing log file to something else. Then open the old log file name up once again. Intended to be called by a JMX agent.

Parameters:
  `newFileName` - The file name to move the log file entry to
Returns:
  true if a file was rotated with no error

#### log

    public void log(String message)

Log the specified message to the log file, switching files if the date has changed since the previous log call.

Parameters:
  `message` - Message to be logged

#### open

    protected void open()

Open the new log file for the date specified by `dateStamp`.

#### findLocale

    protected static Locale findLocale(String name,
                    Locale fallback)

Find a locale by name

#### startInternal

    protected void startInternal()
                          throws LifecycleException

Start this component and implement the requirements of `LifecycleBase.startInternal()`.

Overrides:
  `startInternal` in class `ValveBase`
Throws:
  `LifecycleException` - if this component detects a fatal error that prevents this component from being used

#### stopInternal

    protected void stopInternal()
                         throws LifecycleException

Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.

Overrides:
  `stopInternal` in class `ValveBase`
Throws:
  `LifecycleException` - if this component detects a fatal error that prevents this component from being used

#### createLogElements

    protected AccessLogValve.AccessLogElement[] createLogElements()

parse pattern string and create the array of AccessLogElement

#### createAccessLogElement

    protected AccessLogValve.AccessLogElement createAccessLogElement(String header,
                                                         char pattern)

create an AccessLogElement implementation which needs header string

#### createAccessLogElement

    protected AccessLogValve.AccessLogElement createAccessLogElement(char pattern)

create an AccessLogElement implementation